<?php
/**
 * Plugin Qcm (addon for plugin Adm_redacteurs)
 * Version  : 1.3 (2018/04/12)
 * Compatibility : Guppy v5.0+ et Adm_redacteurs v6.12+
 * Author   : jérôme CROUX (jchouix)
 * Web site : http://lebrikabrak.info/
 * E-mail   : lebrikabrak@free.fr
 * Licence  : GNU Lesser General Public License
 */

defined('ADMR_DIRNAME') OR exit('No direct script access allowed');

/*
|--------------------------------------------------------------------------
| Initialisation des constantes et des fonctions utilisées dans le plugin
|--------------------------------------------------------------------------
*/

/**
 * ROOT
 */
define('QCM_DIRNAME', 'qcm');
define('QCM_PLUGIN_VERSION', '1.3');
define('QCM_PUBLIC_ROOT_PATH', CHEMIN.'plugins/'.QCM_DIRNAME);
define('QCM_ADMIN_ROOT_PATH',  CHEMIN.'admin/plugins/'.QCM_DIRNAME);
define('QCM_ADDON_PATH',       ADMR_ADDONS_PATH.'/'.QCM_DIRNAME);      // Addon

define('QCM_PUBLIC_FILE_PATH', str_replace(CHEMIN, '', QCM_PUBLIC_ROOT_PATH).'/qcm.php'); // Chemin du fichier accessible coté public (Ne pas modifier !)

/**
 * MAIN DIRECTORIES
 */
define('QCM_ASSETS_PATH',      QCM_ADDON_PATH.'/assets');      // Assets
define('QCM_CONFIGS_PATH',     QCM_ADDON_PATH.'/configs');     // Config
define('QCM_CONTROLLERS_PATH', QCM_ADDON_PATH.'/controllers'); // Controllers
define('QCM_HELPERS_PATH',     QCM_ADDON_PATH.'/helpers');     // Helpers
define('QCM_LANGUAGES_PATH',   QCM_ADDON_PATH.'/languages');   // Languages
define('QCM_LIBRARIES_PATH',   QCM_ADDON_PATH.'/libraries');   // Libraries
define('QCM_MODELS_PATH',      QCM_ADDON_PATH.'/models');      // Models
define('QCM_VIEWS_PATH',       QCM_ADDON_PATH.'/views');       // Views

/**
 * ASSETS
 */
define('QCM_CSS_PATH',             QCM_ASSETS_PATH.'/css');		 // Chemin du répertoire CSS
define('QCM_IMG_PATH',             QCM_ASSETS_PATH.'/img');        // Chemin du répertoire images
define('QCM_JS_PATH',              QCM_ASSETS_PATH.'/js');		 // Chemin du répertoire javascript
define('QCM_EDITORS_CONFIG_PATH',  QCM_ASSETS_PATH.'/editors');    // Chemin du répertoire des éditeurs
define('QCM_CKEDITOR_CONFIG_PATH', QCM_EDITORS_CONFIG_PATH.'/ckeditor_config/config.js'); // Chemin du fichier de la configuration de ckeditor

/**
 * IMAGES
 */    
define('QCM_IMG_NEXT',          QCM_IMG_PATH.'/next.gif');       // Lien suivant
define('QCM_IMG_PREVIOUS',      QCM_IMG_PATH.'/previous.gif');   // Lien précédent

/**
 * DATA
 */
define('QCM_DATA_PATH',            CHEMIN.'data/plugins/'.QCM_DIRNAME);        // Chemin du répertoire contenant les données du plugin
define('QCM_IDS_DB',               QCM_DATA_PATH.'/qcm_ids'.DBEXT);       // Chemin du fichier contenant les id des documents présents dans la base 
define('QCM_NEXTID_DB',            QCM_DATA_PATH.'/qcm_nextid'.DBEXT);    // Chemin du fichier contenant l'id du dernier document ajouté
define('QCM_MENUITEMS_DB',         QCM_DATA_PATH.'/qcm_menuitems'.DBEXT); // Chemin du fichier contenant les associations document avec items de menus
define('QCM_PARAMS_PATH',          QCM_DATA_PATH.'/params');                   // Chemin du répertoire contenant les données des documents
define('QCM_PARAMS_FILE_PREFIX',   'qcm_params_');                             // Préfixe du nom du fichier contenant les données du document
define('QCM_COUNTERS_PATH',        QCM_DATA_PATH.'/counters');                 // Chemin du répertoire contenant les compteurs de vues des documents
define('QCM_COUNTERS_FILE_PREFIX', 'qcm_counter_');                            // Préfixe du nom du fichier contenant les compteurs de vues des documents


//define('QCM_QUESTIONS_IDS_DB',     QCM_DATA_PATH.'/qcm_questions_ids'.DBEXT);       // Chemin du fichier contenant les id des documents questions des qcm présents dans la base 
define('QCM_QUESTIONS_IDS_DB_PATH',    QCM_DATA_PATH.'/questions/index');       // Chemin du fichier contenant les id des documents questions des qcm présents dans la base 
define('QCM_QUESTIONS_IDS_DB_PREFIX',  'qcm_questions_ids_');       // Chemin du fichier contenant les id des documents questions des qcm présents dans la base 
define('QCM_QUESTIONS_NEXTID_DB',      QCM_QUESTIONS_IDS_DB_PATH.'/qcm_questions_nextid'.DBEXT);    // Chemin du fichier contenant l'id du dernier document ajouté
define('QCM_QUESTIONS_PATH',           QCM_DATA_PATH.'/questions');             // Chemin du répertoire contenant les questions du qcm
define('QCM_QUESTIONS_FILE_PREFIX',   'qcm_questions_');                       // Préfixe du nom du fichier contenant les questions du qcm
//